Option Explicit

' Copyright  1994 by Computer Technologies, Inc. All rights reserved.

' Application specific globals

Global gtWallpapers(20)             As String
Global gtOrigWallpaper              As String
Global gtTileCenter                 As String
Global gtWinIni                     As String

' Structure used to get bitmap size info
Type BITMAPSIZE
    biFileHdr       As String * 14
    biSize          As Long
    biWidth         As Long
    biHeight        As Long
End Type

' MsgBox parameters
Global Const MB_OK = 0                 ' OK button only
Global Const MB_OKCANCEL = 1           ' OK and Cancel buttons
Global Const MB_ABORTRETRYIGNORE = 2   ' Abort, Retry, and Ignore buttons
Global Const MB_YESNOCANCEL = 3        ' Yes, No, and Cancel buttons
Global Const MB_YESNO = 4              ' Yes and No buttons
Global Const MB_RETRYCANCEL = 5        ' Retry and Cancel buttons

Global Const MB_ICONSTOP = 16          ' Critical message
Global Const MB_ICONQUESTION = 32      ' Warning query
Global Const MB_ICONEXCLAMATION = 48   ' Warning message
Global Const MB_ICONINFORMATION = 64   ' Information message

Global Const MB_APPLMODAL = 0          ' Application Modal Message Box
Global Const MB_DEFBUTTON1 = 0         ' First button is default
Global Const MB_DEFBUTTON2 = 256       ' Second button is default
Global Const MB_DEFBUTTON3 = 512       ' Third button is default
Global Const MB_SYSTEMMODAL = 4096      'System Modal

' MsgBox return values
Global Const IDOK = 1                  ' OK button pressed
Global Const IDCANCEL = 2              ' Cancel button pressed
Global Const IDABORT = 3               ' Abort button pressed
Global Const IDRETRY = 4               ' Retry button pressed
Global Const IDIGNORE = 5              ' Ignore button pressed
Global Const IDYES = 6                 ' Yes button pressed
Global Const IDNO = 7                  ' No button pressed

'File Open/Save Dialog Flags
Global Const OFN_READONLY = &H1&
Global Const OFN_OVERWRITEPROMPT = &H2&
Global Const OFN_HIDEREADONLY = &H4&
Global Const OFN_NOCHANGEDIR = &H8&
Global Const OFN_SHOWHELP = &H10&
Global Const OFN_NOVALIDATE = &H100&
Global Const OFN_ALLOWMULTISELECT = &H200&
Global Const OFN_EXTENTIONDIFFERENT = &H400&
Global Const OFN_PATHMUSTEXIST = &H800&
Global Const OFN_FILEMUSTEXIST = &H1000&
Global Const OFN_CREATEPROMPT = &H2000&
Global Const OFN_SHAREAWARE = &H4000&
Global Const OFN_NOREADONLYRETURN = &H8000&

' SystemParametersInfo constants
Global Const SPI_SETDESKWALLPAPER = 20
Global Const SPIF_SENDWININICHANGE = &H2
Global Const SPIF_UPDATEINIFILE = &H1

Declare Function APIGetPrivateProfileString Lib "Kernel" Alias "GetPrivateProfileString" (ByVal lpAppName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer, ByVal lpFilename As String) As Integer
Declare Function APIWritePrivateProfileString Lib "Kernel" Alias "WritePrivateProfileString" (ByVal lpAppName As String, ByVal lpKeyName As String, ByVal lpString As String, ByVal lplFileName As String) As Integer
Declare Function APISystemParametersInfo Lib "User" Alias "SystemParametersInfo" (ByVal uAction As Integer, ByVal uParam As Integer, lpvParam As Any, ByVal fuWinIni As Integer) As Integer
Declare Function APIGetWindowsDirectory Lib "Kernel" Alias "GetWindowsDirectory" (ByVal lpBuffer As String, ByVal nSize As Integer) As Integer

Sub APP_AddHistory (tFile As String)

' Copyright  1994 by Computer Technologies, Inc. All rights reserved.

' Add a new wallpaper to the head of the past wallpapers list

    Dim nLoopCtr        As Integer

    If Trim$(tFile) = Trim$(gtWallpapers(1)) Or tFile = "" Or tFile = "(None)" Then Exit Sub
    
    For nLoopCtr = 20 To 2 Step -1
	gtWallpapers(nLoopCtr) = gtWallpapers(nLoopCtr - 1)
    Next nLoopCtr
    gtWallpapers(1) = Trim$(tFile)

End Sub

Sub APP_ChangeWallpaper (tFile As String, tMode As String)

' Copyright  1994 by Computer Technologies, Inc. All rights reserved.

    Dim lResult             As Long
    Dim nResult             As Integer
    
    lResult = APIWritePrivateProfileString("Desktop", "TileWallPaper", tMode, gtWinIni)
    nResult = APISystemParametersInfo(SPI_SETDESKWALLPAPER, 0, ByVal tFile, SPIF_UPDATEINIFILE)
    DoEvents

End Sub

Sub APP_GetHistory ()

' Copyright  1994 by Computer Technologies, Inc. All rights reserved.

' Read application INI file for past wallpapers and load the combo list

    Dim tReturnStr          As String * 256
    Dim lRetSize            As Long
    Dim nLoopCtr            As Integer
    Dim nBufSize            As Integer
    Dim tIniFile            As String
    Dim tTempStr            As String

    nBufSize = 256
    tIniFile = App.Path & "\VB-WALL.INI"

    For nLoopCtr = 1 To 20
	tTempStr = "Bitmap" & Trim$(Str$(nLoopCtr))
	lRetSize = APIGetPrivateProfileString("WallPapers", tTempStr, "", tReturnStr, nBufSize, tIniFile)
	gtWallpapers(nLoopCtr) = Trim$(Left$(tReturnStr, lRetSize))
	If gtWallpapers(nLoopCtr) = "" Then Exit For
	frmWallPaper!cboBitmap.AddItem gtWallpapers(nLoopCtr)
    Next nLoopCtr

    frmWallPaper!cboBitmap.AddItem "(None)"
    
    frmWallPaper!cboBitmap.ListIndex = 0
    frmWallPaper!cboBitmap.SelStart = 0
    frmWallPaper!cboBitmap.SelLength = Len(gtWallpapers(1))

End Sub

Sub APP_Preview (tFile As String)

' Copyright  1994 by Computer Technologies, Inc. All rights reserved.

    Dim bmiSize             As BITMAPSIZE
    Dim nChannel            As Integer
    Dim sXRatio             As Single
    Dim sYRatio             As Single
    
' Check for a no wallpaper situation
    If tFile = "" Or tFile = "(None)" Then
	frmWallPaper!imgPreview.Picture = LoadPicture("")
	Exit Sub
    End If

' Get a free channel, open the bitmap, and get it's dimensions
    nChannel = FreeFile
    On Error GoTo PreviewOpenFail
    Open tFile For Binary As nChannel
    Get nChannel, 1, bmiSize
    Close nChannel
    On Error GoTo 0

' Clear and reset the image comtrol
    frmWallPaper!imgPreview.Picture = LoadPicture("")
    frmWallPaper!imgPreview.Width = (Screen.Width / Screen.TwipsPerPixelX) \ 10
    frmWallPaper!imgPreview.Height = (Screen.Height / Screen.TwipsPerPixelY) \ 10

' Calculate and set the size of the target image control
    sXRatio = bmiSize.biWidth / frmWallPaper!imgPreview.Width
    sYRatio = bmiSize.biHeight / frmWallPaper!imgPreview.Height
    Select Case sXRatio
	Case Is > sYRatio
	    frmWallPaper!imgPreview.Width = bmiSize.biWidth \ sXRatio
	    frmWallPaper!imgPreview.Height = bmiSize.biHeight \ sXRatio
	Case Is <= sYRatio
	    frmWallPaper!imgPreview.Width = bmiSize.biWidth \ sYRatio
	    frmWallPaper!imgPreview.Height = bmiSize.biHeight \ sYRatio
    End Select

' Load the bitmap into the preview image
    frmWallPaper!imgPreview.Stretch = True              ' Resize the picture to the control
    frmWallPaper!imgPreview.Picture = LoadPicture(tFile)

    GoTo PreviewExit

PreviewOpenFail:
    MsgBox "Unable to open the specified bitmap file.", MB_ICONSTOP, "VB-WALL Error"
    Resume PreviewExit

PreviewExit:

End Sub

Sub APP_SaveHistory ()

' Copyright  1994 by Computer Technologies, Inc. All rights reserved.

    Dim lResult             As Long
    Dim nLoopCtr            As Integer

    For nLoopCtr = 1 To 20
	If gtWallpapers(nLoopCtr) = "" Then Exit For
	lResult = APIWritePrivateProfileString("WallPapers", "Bitmap" & Trim$(Str$(nLoopCtr)), gtWallpapers(nLoopCtr), App.Path & "\VB-WALL.INI")
    Next nLoopCtr

End Sub

Sub Main ()

' Copyright  1994 by Computer Technologies, Inc. All rights reserved.

    Dim nResult             As Integer
    Dim tRunCmd             As String
    Dim tReturnStr          As String * 256
    Dim nBufSize            As Integer
    Dim lResult             As Long
    Dim tTempStr            As String

    tRunCmd = UCase$(Trim$(Command$))

    gtWinIni = UT_WindowsDir() & "\WIN.INI"
    
    If tRunCmd = "" Then
	nBufSize = 256
	lResult = APIGetPrivateProfileString("Desktop", "wallpaper", "", tReturnStr, nBufSize, gtWinIni)
	gtOrigWallpaper = Trim$(Left$(tReturnStr, lResult))
	lResult = APIGetPrivateProfileString("Desktop", "TileWallPaper", "", tReturnStr, nBufSize, gtWinIni)
	gtTileCenter = Trim$(Left$(tReturnStr, lResult))
	frmWallPaper.Show
      
      Else                  ' We got a command to parse
	
	If InStr(tRunCmd, "/C") > 0 Then        ' Set center
	    lResult = APIWritePrivateProfileString("Desktop", "TileWallPaper", "0", gtWinIni)
	End If
	
	If InStr(tRunCmd, "/T") > 0 Then        ' Set tile
	    lResult = APIWritePrivateProfileString("Desktop", "TileWallPaper", "1", gtWinIni)
	End If
	
	If InStr(tRunCmd, "/W") > 0 Then        ' Set wall paper file
	    tTempStr = Mid$(tRunCmd, InStr(tRunCmd, "/W") + 2)          ' Get the command section with the filename
	    tTempStr = Mid$(tTempStr, InStr(tTempStr, "=") + 1)         ' Strip out the command switch
	    If InStr(tTempStr, " ") <> 0 Then                           ' Get the file name itself if delimited by " "
		tTempStr = Left$(tTempStr, InStr(tTempStr, " ") - 1)
	    End If
	    If InStr(tTempStr, "/") <> 0 Then                           ' Get the file name itself if delimited by "/"
		tTempStr = Left$(tTempStr, InStr(tTempStr, "/") - 1)
	    End If
	    lResult = APIGetPrivateProfileString("Desktop", "TileWallPaper", "", tReturnStr, nBufSize, gtWinIni)
	    gtTileCenter = Trim$(Left$(tReturnStr, lResult))
	    Call APP_ChangeWallpaper(tTempStr, gtTileCenter)
	End If
	
	End                                     ' Exit from the program
    
    End If
    
End Sub

Sub UT_CenterScreen (frmSubForm As Form)

' Copyright  1993, 1994 by Computer Technologies, Inc. All rights reserved.

' This procedure centers a form on the screen. The form
' will be offset to just above center on the vertical axis.

    Dim nLeftPos      As Integer
    Dim nTopPos       As Integer

    nLeftPos = (Screen.Width - frmSubForm.Width) / 2
    nTopPos = (Screen.Height - frmSubForm.Height) / 2.4

    frmSubForm.Move nLeftPos, nTopPos

End Sub

Function UT_WindowsDir () As String

' Copyright  1994 by Computer Technologies, Inc. All rights reserved.

    Dim tTempStr            As String
    Dim nResult             As Integer

    tTempStr = Space$(144)
    nResult = APIGetWindowsDirectory(tTempStr, Len(tTempStr))
    tTempStr = Trim$(tTempStr)
    UT_WindowsDir = Left$(tTempStr, Len(tTempStr) - 1)

End Function

